/*
 * Definitions for UDPBIND VERSION 1 NUMBER 20192.
 */
#ifndef __UDPBIND
#define __UDPBIND
#include <HRPC/cCourierTypes.h>
#include <HRPC/basicRpc.h>
#include <HRPC/hrpcErrCodes.h>


/*
 * Definitions from DEPENDS UPON BIND_MsgStructs inclusion
 * (must be linked with BIND_MsgStructs_otw.c also)
 */

#include <HRPC/CIncludes/BIND_MsgStructs.h>

typedef struct {
	BIND_MsgStructs_LookupNameInMsg Msg;
} UDPBIND_LookupNameInMsg;
extern int UDPBIND_LookupNameInMsgOtw();

typedef struct {
	BIND_MsgStructs_LookupNameOutMsg Msg;
} UDPBIND_LookupNameOutMsg;
extern int UDPBIND_LookupNameOutMsgOtw();

typedef struct {
	BIND_MsgStructs_AddRRInMsg Msg;
} UDPBIND_AddRRInMsg;
extern int UDPBIND_AddRRInMsgOtw();

typedef struct {
	BIND_MsgStructs_AddRROutMsg Msg;
} UDPBIND_AddRROutMsg;
extern int UDPBIND_AddRROutMsgOtw();

typedef struct {
	BIND_MsgStructs_DeleteRRInMsg Msg;
} UDPBIND_DeleteRRInMsg;
extern int UDPBIND_DeleteRRInMsgOtw();

typedef struct {
	BIND_MsgStructs_DeleteRROutMsg Msg;
} UDPBIND_DeleteRROutMsg;
extern int UDPBIND_DeleteRROutMsgOtw();

typedef struct {
	BIND_MsgStructs_ModifyInMsg Msg;
} UDPBIND_ModifyInMsg;
extern int UDPBIND_ModifyInMsgOtw();

typedef struct {
	BIND_MsgStructs_ModifyOutMsg Msg;
} UDPBIND_ModifyOutMsg;
extern int UDPBIND_ModifyOutMsgOtw();

#ifndef HRPC_SERVER
extern HRPCErrRec * UDPBIND_LookupName();
#else
extern void UDPBIND_LookupName();
#endif
#define UDPBIND_LOOKUPNAME 1

#ifndef HRPC_SERVER
extern HRPCErrRec * UDPBIND_AddRR();
#else
extern void UDPBIND_AddRR();
#endif
#define UDPBIND_ADDRR 1

#ifndef HRPC_SERVER
extern HRPCErrRec * UDPBIND_DeleteRR();
#else
extern void UDPBIND_DeleteRR();
#endif
#define UDPBIND_DELETERR 1

#ifndef HRPC_SERVER
extern HRPCErrRec * UDPBIND_Modify();
#else
extern void UDPBIND_Modify();
#endif
#define UDPBIND_MODIFY 1

#endif __UDPBIND


extern HRPCErrRec *UDPBIND_Export();
extern HRPCErrRec *UDPBIND_Import();
